#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1600seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven16004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven16004xi = {
                1:'-1005x-824y932z',
                2:'-1022x-1229y51z',
                3:'-1039x-764y945z',
                4:'-1043x-1043y618z',
                5:'-106x-799y1381z',
                6:'-1070x-704y958z',
                7:'-1084x-1174y67z',
                8:'-1091x-983y633z',
                9:'-1097x-642y971z',
                10:'-1120x-579y983z',
                11:'-1136x-920y648z',
                12:'-1140x-515y996z',
                13:'-1144x-1115y83z',
                14:'-1156x-451y1008z',
                15:'-1169x-387y1021z',
                16:'-1177x-322y1033z',
                17:'-1178x-855y662z',
                18:'-1182x-258y1045z',
                19:'-1200x-1053y99z',
                20:'-1215x-789y677z',
                21:'-1249x-721y691z',
                22:'-1253x-988y115z',
                23:'-1279x-651y706z',
                24:'-1302x-920y131z',
                25:'-1305x-581y720z',
                26:'-1326x-509y734z',
                27:'-1344x-436y749z',
                28:'-1347x-850y147z',
                29:'-1358x-363y763z',
                30:'-1368x-290y777z',
                31:'-1373x-217y791z',
                32:'-1375x-144y804z',
                33:'-1388x-777y163z',
                34:'-140x-1417y727z',
                35:'-1425x-703y179z',
                36:'-1458x-627y195z',
                37:'-145x-779y1389z',
                38:'-1487x-549y211z',
                39:'-14x-15y1599z',
                40:'-1512x-469y226z',
                41:'-1532x-389y242z',
                42:'-15x-228y1583z',
                43:'-161x-1534y422z',
                44:'-182x-757y1397z',
                45:'-213x-1401y742z',
                46:'-218x-733y1405z',
                47:'-22x-833y1365z',
                48:'-240x-1519y437z',
                49:'-24x-28y1599z',
                50:'-251x-707y1412z',
                51:'-25x-211y1585z',
                52:'-282x-680y1420z',
                53:'-285x-1380y756z',
                54:'-311x-651y1427z',
                55:'-319x-1500y453z',
                56:'-32x-42y1599z',
                57:'-338x-621y1434z',
                58:'-33x-194y1587z',
                59:'-355x-1356y770z',
                60:'-363x-591y1441z',
                61:'-385x-559y1448z',
                62:'-38x-57y1598z',
                63:'-395x-1477y468z',
                64:'-3x-244y1581z',
                65:'-405x-526y1455z',
                66:'-40x-176y1589z',
                67:'-422x-493y1461z',
                68:'-423x-1328y784z',
                69:'-438x-460y1468z',
                70:'-43x-73y1597z',
                71:'-447x-82y1533z',
                72:'-450x-426y1474z',
                73:'-457x-109y1529z',
                74:'-45x-159y1591z',
                75:'-461x-393y1480z',
                76:'-465x-137y1524z',
                77:'-469x-359y1486z',
                78:'-471x-1450y483z',
                79:'-472x-166y1519z',
                80:'-475x-325y1492z',
                81:'-477x-196y1514z',
                82:'-478x-292y1498z',
                83:'-479x-228y1509z',
                84:'-47x-89y1596z',
                85:'-480x-260y1503z',
                86:'-489x-1297y798z',
                87:'-48x-141y1593z',
                88:'-49x-106y1595z',
                89:'-49x-123y1594z',
                90:'-4x-3y1599z',
                91:'-544x-1419y499z',
                92:'-553x-1262y812z',
                93:'-611x-515y1385z',
                94:'-615x-1224y825z',
                95:'-616x-1384y514z',
                96:'-626x-474y1393z',
                97:'-630x-591y1463z',
                98:'-638x-433y1401z',
                99:'-648x-392y1409z',
                100:'-655x-350y1416z',
                101:'-65x-817y1373z',
                102:'-660x-310y1423z',
                103:'-662x-269y1431z',
                104:'-66x-1430y713z',
                105:'-674x-1183y839z',
                106:'-685x-1345y529z',
                107:'-730x-1139y853z',
                108:'-752x-1302y544z',
                109:'-784x-1092y866z',
                110:'-80x-1545y406z',
                111:'-816x-1257y559z',
                112:'-817x-1375y3z',
                113:'-834x-1043y879z',
                114:'-877x-1208y574z',
                115:'-882x-991y893z',
                116:'-888x-1330y19z',
                117:'-926x-937y906z',
                118:'-936x-1156y589z',
                119:'-956x-1281y35z',
                120:'-967x-881y919z',
                121:'-991x-1101y604z',
                122:'0x-1551y391z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1600seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1600SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE1600SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1600SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1600SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1600SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven16004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1600SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1600SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1600SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven16004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven16004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1600SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1600SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1600SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       